from .atomic import Atomic

__all__ = ('Plain',)


class Plain(Atomic):
    def __init__(self, source: bytes):
        assert isinstance(source, bytes)
        self.source = source

    @classmethod
    def _from_bytes(cls, source: bytes) -> 'Plain':
        assert isinstance(source, bytes)
        return cls(source)

    def __bytes__(self):
        return self.source

    def __str__(self):
        return self.source.decode(errors='replace')
