import abc
from typing import Generic, TypeVar

from rainbowadn.core import *
from .blockcollectioninterface import BlockCollectionInterface

__all__ = ('ChainCollectionInterface',)

BlockType = TypeVar('BlockType')
HeaderType = TypeVar('HeaderType')
ActualStateType = TypeVar('ActualStateType')


class ChainCollectionInterface(
    BlockCollectionInterface[
        BlockType,
        HeaderType,
        ActualStateType
    ],
    Generic[BlockType, HeaderType, ActualStateType],
    abc.ABC
):
    async def add(
            self,
            header: HashPoint[HeaderType]
    ) -> 'ChainCollectionInterface[BlockType, HeaderType, ActualStateType]':
        raise NotImplementedError

    async def verify(self) -> bool:
        raise NotImplementedError
