from typing import Generic, TypeVar

from rainbowadn.core import *
from .derived import Derived

__all__ = ('DerivedState',)

BaseStateType = TypeVar('BaseStateType')
StageType = TypeVar('StageType')


class DerivedState(Derived[BaseStateType, StageType], Generic[BaseStateType, StageType]):
    def __init__(self, state: HashPoint[BaseStateType]):
        assert isinstance(state, HashPoint)
        self.state = state
