from typing import Generic, TypeVar

from rainbowadn.chain.chaincollectionfactory import ChainCollectionFactory
from rainbowadn.core import *
from .reductionprotocol import ReductionProtocol

__all__ = ('AbstractReductionChainMetaFactory',)

BlockType = TypeVar('BlockType')
ReductorType = TypeVar('ReductorType')
AccumulatorType = TypeVar('AccumulatorType')


class AbstractReductionChainMetaFactory(
    Generic[BlockType, ReductorType, AccumulatorType]
):
    def factory(
            self,
            reductor_factory: RainbowFactory[ReductorType],
            accumulator_factory: RainbowFactory[AccumulatorType],
            protocol: ReductionProtocol[ReductorType, AccumulatorType],
    ) -> ChainCollectionFactory[
        BlockType, ReductorType, AccumulatorType
    ]:
        raise NotImplementedError
