from typing import Generic, TypeVar

from rainbowadn.core import *
from .reducible import Reducible
from .reductionresult import ReductionResult

__all__ = ('ReductionProtocol',)

ReductorType = TypeVar('ReductorType')
AccumulatorType = TypeVar('AccumulatorType')


class ReductionProtocol(Generic[ReductorType, AccumulatorType]):
    async def reduce(
            self,
            reduce: Reducible[ReductorType, AccumulatorType]
    ) -> ReductionResult[ReductorType, AccumulatorType]:
        raise NotImplementedError

    def initial(self, factory: RainbowFactory[AccumulatorType]) -> HashPoint[AccumulatorType]:
        raise NotImplementedError

    async def header_filter(
            self,
            state: HashPoint[AccumulatorType]
    ) -> HashPoint[AccumulatorType]:
        raise NotImplementedError
