from typing import Generic, TypeVar

from rainbowadn.chain.states import *
from rainbowadn.core import *
from rainbowadn.nullability import *
from .stagestate import StateStage

__all__ = ('StageStateProtocol',)

HeaderType = TypeVar('HeaderType')
BaseStateType = TypeVar('BaseStateType')
StageType = TypeVar('StageType')


class StageStateProtocol(
    StateProtocol[HeaderType, StateStage[HeaderType, BaseStateType, StageType]],
    Generic[HeaderType, BaseStateType, StageType]
):
    async def verify(
            self,
            previous: NullableReference[StateStage[HeaderType, BaseStateType, StageType]],
            header: HashPoint[HeaderType],
            state: HashPoint[StateStage[HeaderType, BaseStateType, StageType]]
    ) -> bool:
        assert isinstance(previous, NullableReference)
        assert isinstance(header, HashPoint)
        assert isinstance(state, HashPoint)
        assert_true(await (await state.resolve()).verify(previous, header))
        return True
