from typing import TypeVar

from rainbowadn.core import *
from rainbowadn.nullability import *
from .stateprotocol import StateProtocol

__all__ = ('ActiveStateProtocol',)

HeaderType = TypeVar('HeaderType')
StateType = TypeVar('StateType')


class ActiveStateProtocol(StateProtocol[HeaderType, StateType]):
    async def verify(
            self,
            previous: NullableReference[StateType],
            header: HashPoint[HeaderType],
            state: HashPoint[StateType]
    ) -> bool:
        assert isinstance(previous, NullableReference)
        assert isinstance(header, HashPoint)
        assert isinstance(state, HashPoint)
        assert_eq(state, await self.derive(previous, header))
        return True

    async def derive(
            self,
            previous: NullableReference[StateType],
            header: HashPoint[HeaderType],
    ) -> HashPoint[StateType]:
        raise NotImplementedError
