import abc
from typing import Generic, TypeVar

from rainbowadn.core import *

__all__ = (
    'Comparison',
    'Left',
    'Right',
    'Equal',
    'Replace',
    'Fail',
    'Duplicate',
    'Comparator',
)


class Comparison(abc.ABC):
    pass


class Left(Comparison):
    pass


class Right(Comparison):
    pass


class Equal(Comparison):
    pass


class Replace(Equal):
    pass


class Fail(Equal):
    pass


class Duplicate(Equal):
    pass


KeyType = TypeVar('KeyType')


class Comparator(Generic[KeyType]):
    async def compare(self, original: HashPoint[KeyType], key: HashPoint[KeyType]) -> Comparison:
        raise NotImplementedError
