from rainbowadn.atomic.plain import Plain
from rainbowadn.core import *
from .comparator import *
from .protocolcomparator import ProtocolComparator

__all__ = ('PlainComparator',)


class PlainComparator(ProtocolComparator[Plain]):
    async def compare(self, original: HashPoint[Plain], key: HashPoint[Plain]) -> Comparison:
        assert isinstance(original, HashPoint)
        assert isinstance(key, HashPoint)
        original_value: Plain
        key_value: Plain
        original_value, key_value = await gather(
            original.resolve(),
            key.resolve(),
        )
        assert isinstance(original_value, Plain)
        assert isinstance(key_value, Plain)
        if key_value.source < original_value.source:
            return Left()
        elif key_value.source > original_value.source:
            return Right()
        else:
            return self.equal
