from typing import Generic, TypeVar

from .mentionable import Mentionable
from .origin import Origin

__all__ = ('LocalOrigin',)

Mentioned = TypeVar('Mentioned')


class LocalOrigin(Origin[Mentioned], Generic[Mentioned]):
    def __init__(self, value: Mentioned):
        assert isinstance(value, Mentionable)
        super().__init__(value.__factory__())
        self.value: Mentioned = value

    async def resolve(self) -> Mentioned:
        return self.value
