from typing import Generic, TypeVar

from .rainbow_factory import RainbowFactory

__all__ = ('Origin',)

Mentioned = TypeVar('Mentioned')


class Origin(Generic[Mentioned]):
    def __init__(self, factory: RainbowFactory[Mentioned]):
        assert isinstance(factory, RainbowFactory)
        self.factory = factory

    async def resolve(self) -> Mentioned:
        raise NotImplementedError
