from typing import Generic, TypeVar

from .asserts import *
from .hashpoint import HashPoint
from .hashresolver import HashResolver
from .metaorigin import MetaOrigin
from .origin import Origin
from .rainbow_factory import RainbowFactory
from .resolverorigin import ResolverOrigin

__all__ = ('ResolverMetaOrigin',)

Mentioned = TypeVar('Mentioned')


class ResolverMetaOrigin(MetaOrigin[Mentioned], Generic[Mentioned]):
    def __init__(self, resolver: HashResolver):
        assert isinstance(resolver, HashResolver)
        self.resolver = resolver

    def origin(self, factory: RainbowFactory[Mentioned], point: bytes) -> Origin[Mentioned]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert_eq(len(point), HashPoint.HASH_LENGTH)
        return ResolverOrigin(factory, point, self.resolver)
