from .instrumentation import Instrumentation

__all__ = ('Counter',)


class Counter(Instrumentation):
    def __init__(self, target, methodname: str):
        assert isinstance(methodname, str)
        super().__init__(target, methodname)
        self.counter = 0

    def instrument(self, method, *args, **kwargs):
        self.counter += 1
        return method(*args, **kwargs)
